%define debug_package %{nil}
%define daemon_name ovs-devmon

Name:      devmon
Version:   1.0
Release: 28.1
Summary:   System device Monitor for Oracle OVS
License:   GPLv2
Group:     System Environment/Daemons
URL:       http://www.oracle.com/virtualization
Source:    %{name}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Requires:  ovs-agent >= 3.0

Patch1: sd-events.patch
Patch2: rpm-target.patch
Patch3: missing-add-sd.patch
Patch4: rem-dm.patch
Patch5: organize-logfile.patch
Patch6: empty-add-sd.patch
Patch7: change-license-to-gplv2.patch
Patch8: add-license-header.patch
Patch9: bond-link-change.patch
Patch10: infiniband-link-state.patch
Patch11: devmon-infinband.patch
Patch12: notification.patch
Patch13: fix-agent-notification-module-path.patch
Patch14: remove-reload.patch
Patch15: enic-link-state.patch
Patch16: ipoib-partitions.patch
# End Oracle Patches

%description
devmon daemon for Oracle OVS. Monitors all of the devices and provides health
information via agent notifier.


%prep
%setup -q
%patch1 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0
%patch6 -p0
%patch7 -p0
%patch8 -p0
%patch9 -p0
%patch10 -p0
%patch11 -p0
%patch12 -p0
%patch13 -p0
%patch14 -p0
%patch15 -p0
%patch16 -p0


%build
make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p ${RPM_BUILD_ROOT}/etc/init.d
mkdir -p ${RPM_BUILD_ROOT}/usr/bin
make DESTDIR=${RPM_BUILD_ROOT}
install --mode=755 init.d/ovs-devmon ${RPM_BUILD_ROOT}/etc/init.d/ovs-devmon
install --mode=755 devmon ${RPM_BUILD_ROOT}/usr/bin/devmon


%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
if [ $1 = 1 ]; then
   /sbin/chkconfig --add %{daemon_name}
   if [ $? == 0 ]; then
        /sbin/chkconfig --level 35 %{daemon_name} on
   fi
fi

%preun
if [ $1 = 0 ]; then
   /sbin/service %{daemon_name} stop > /dev/null 2>&1
   /sbin/chkconfig --del %{daemon_name}
fi

%postun
/sbin/ldconfig
if [ $1 -ge 1 ]; then
   /sbin/service %{daemon_name} condrestart >/dev/null 2>&1
fi

%files
%defattr(-,root,root)
%doc COPYING
/etc/init.d/ovs-devmon
/usr/bin/devmon


%changelog
* Fri Apr 12 2013 Chuang Cao <chuang.cao@oracle.com> - 1.0-28.1 
- Fixed devmon so that it can handle the state of IPoIB partitions
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Backported-by: Chuang Cao <chuang.cao@oracle.com> [bug 16088167]  

* Mon Aug 13 2012 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-28 
- re-write the link state detection code to handle virtual nics link state correctly  (enics). [bug 14402887] 

* Wed Aug 01 2012 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-27 
- Remove devmon reload option, it is not needed. [bug 14399588] 

* Wed Apr 25 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 1.0-26 
- fix agent notification module path.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Alexandre Chartre <alexandre.chartre@oracle.com> 

* Thu Dec 15 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 1.0-25 
- fix notification for agent refactor 

* Wed Nov 16 2011 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-24 
- Change the way devmon checks for infiniband devices 

* Thu Nov 03 2011 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-23 
- Fixed devmon to recognize, monitor, and report infiniband devices link state. 

* Wed Aug 31 2011 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-22 
- Changed devmon to use the interface flags (IFF_UP,IFF_DOWN) to determine
  bond link change instead of ethtool/or MII, as bond interfaces are logical
  and their link state can not be detected. [bug 12904169] 

* Fri Aug 26 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 1.0-21 
- add license header. [bug 12737215] 

* Tue Jul 12 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 1.0-20 
- change license to gplv2
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 12737215] 

* Wed Jul 06 2011 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-19 
- Prevent devmon from reporting extra empty ADD_SD messages [bug 12696983] 

* Fri Jun 24 2011 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-18 
- Better organize data in log file 

* Thu Jun 23 2011 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-17 
- Remove code that handle a case of REM_DM processing which is not applicable to OVS.
  It causes extra empty REM_DM messages be sent while they where already handled [bug 12426402] 

* Wed Jun 08 2011 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-16 
- I used iscsiadm -m node -p 10.196.210.25 --login/logout over 50 times to present/un-present
  10 ISCSI LUNs. The result was good every time. If you still see a missing ADD_SD,
  then I will needed your test environment for a few hours. [bug 12573959] 

* Wed May 25 2011 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-15 
- Add RPM target, changes devmon service name to ovs-devmon 

* Tue May 24 2011 Kevin Lyons <kevin.x.lyons@oracle.com> - 1.0-14 
- Rename devmon init script to ovs-devmon and rebase package in tarball.

* Tue May 24 2011 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-13 
- give multipathd a chance to catch up first fefore sending ADD SD otherwise we 
may miss the event. [bug 12573959]

* Fri May 13 2011 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-12 
- Devmon does not fork python processes to storage_discover any more. This should
  reduce the amount of memory consumed during LUN present/un-present.
  The test should be repeated to see how much was gained.
  OraclBug:12418855 

* Fri May 13 2011 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-11 
- A connection time is a result of a bad connection to the target, which caused devmon
  to exit at start up time. I changed the logic so that devmon will not exit and tries
  again during its main loop. [bug 11878958] 

* Mon Dec 13 2010 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-10 
- Do not keep track, report vifs state change to the manager. It is not needed. [bug 10211503] 

* Tue Nov 30 2010 Cathy Avery <cathy.avery@oracle.com> - 1.0-9 
- Added port name to [ADD_FC_TRG] event. 

* Tue Nov 23 2010 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-8 
- Remove guest memory cushion. It is not need for OVM 

* Wed Nov 10 2010 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-7 
- Stop the reaper thread from running, it is removing the DMs after all the SDs under it are gone.
  This is not needed for this product. 

* Wed Oct 06 2010 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-6 
- Fix xenstored hang which made xend appears to be hanging. The problem was caused by
  devmon excessive access to xenstored that left many xenstored handle open.
  orabug:10155532 

* Tue Sep 21 2010 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-5 
- Apply patch to make/spec files to satisfy the patch. 

* Mon Sep 20 2010 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-4 
- Redirect PyErr_Print output to a string to catch agent_notify exception
  start devmon automatically at boot time. 

* Wed Sep 01 2010 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-3
- Made some changes to accommodates changes in the notifier.

* Thu Aug 19 2010 Cathy Avery <cathy.avery@oracle.com> - 1.0-2
- devmon was routing udev events to udev2multipathd daemon so it would not see
the storage or iscsi events.

* Thu Jul 8 2010 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-1
- initial devmon spec file
